
set echo on
set wrap on
col jobs format a90
col distinct_jobs format a90
break on deptno skip 1

SELECT deptno
,      CAST(COLLECT(job) AS varchar2_ntt) AS jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(DISTINCT job) 
             AS varchar2_ntt) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(UNIQUE job)
             AS varchar2_ntt) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(ALL job)
             AS varchar2_ntt) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

