
set echo on

CREATE TYPE empsal_ot AS OBJECT
( ename VARCHAR2(30)
, sal   NUMBER
);
/

CREATE TYPE empsal_ntt AS TABLE OF empsal_ot;
/

col empsals format a50 wrap
break on deptno skip 1

SELECT deptno
,      CAST(
          COLLECT(
             empsal_ot(ename, sal)
             ) AS empsal_ntt) AS empsals
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(
             empsal_ot(ename, sal) ORDER BY sal
             ) AS empsal_ntt) AS empsals
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(
             DISTINCT empsal_ot(ename, sal)
             ) AS empsal_ntt) AS empsals
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(
             empsal_ot(ename, sal) 
                ORDER BY empsal_ot(ename, sal)
             ) AS empsal_ntt) AS empsals
FROM   emp
GROUP  BY
       deptno;


