
set echo on

DROP TYPE empsal_ntt;
DROP TYPE empsal_ot FORCE;

CREATE TYPE empsal_ot AS OBJECT
( ename VARCHAR2(30)
, sal   NUMBER
, MAP MEMBER FUNCTION sort_key RETURN VARCHAR2
);
/

CREATE TYPE BODY empsal_ot AS
   MAP MEMBER FUNCTION sort_key RETURN VARCHAR2 IS
   BEGIN
      RETURN ename || TO_CHAR(sal,'fm0000');
   END;
END;
/

CREATE TYPE empsal_ntt AS TABLE OF empsal_ot;
/

col empsals format a60 wrap

SELECT CAST(
          COLLECT(
             empsal_ot(ename, sal) 
                ORDER BY empsal_ot(ename, sal)
             ) AS empsal_ntt) AS empsals
FROM   emp;

INSERT INTO emp (empno, ename, sal)
   VALUES (9999, 'ALLEN', 1600);

SELECT CAST(
          COLLECT(
             DISTINCT empsal_ot(ename, sal)
             ) AS empsal_ntt) AS empsals
FROM   emp;

ROLLBACK;
